org.apache.hc.client5.http.sync

## Interface ExecRuntime

    @Internal
    public interface ExecRuntime

Execution runtime that provides access to the underlying connection endpoint and helps manager its life cycle.

This interface is considered internal and generally ought not be used or accessed by custom request exec handlers.

Since:
  5.0

### Method Summary

Methods
`void` `acquireConnection(HttpRoute route, Object state, HttpClientContext context)`
`void` `connect(HttpClientContext context)`
`void` `discardConnection()`
`void` `disconnect()`
`org.apache.hc.core5.http.ClassicHttpResponse` `execute(org.apache.hc.core5.http.ClassicHttpRequest request, HttpClientContext context)`
`boolean` `isConnected()`
`boolean` `isConnectionAcquired()`
`boolean` `isConnectionReusable()`
`boolean` `isExecutionAborted()`
`void` `markConnectionNonReusable()`
`void` `markConnectionReusable()`
`void` `releaseConnection()`
`void` `setConnectionState(Object state)`
`void` `setConnectionValidFor(org.apache.hc.core5.util.TimeValue duration)`
`void` `upgradeTls(HttpClientContext context)`

### Method Detail

#### isExecutionAborted

    boolean isExecutionAborted()

#### isConnectionAcquired

    boolean isConnectionAcquired()

#### acquireConnection

    void acquireConnection(HttpRoute route,
                         Object state,
                         HttpClientContext context)
                           throws IOException

Throws:
  `IOException`

#### releaseConnection

    void releaseConnection()

#### discardConnection

    void discardConnection()

#### isConnected

    boolean isConnected()

#### disconnect

    void disconnect()
                    throws IOException

Throws:
  `IOException`

#### connect

    void connect(HttpClientContext context)
                 throws IOException

Throws:
  `IOException`

#### upgradeTls

    void upgradeTls(HttpClientContext context)
                    throws IOException

Throws:
  `IOException`

#### execute

    org.apache.hc.core5.http.ClassicHttpResponse execute(org.apache.hc.core5.http.ClassicHttpRequest request,
                                                       HttpClientContext context)
                                                         throws IOException,
                                                                org.apache.hc.core5.http.HttpException

Throws:
  `IOException`
  `org.apache.hc.core5.http.HttpException`

#### isConnectionReusable

    boolean isConnectionReusable()

#### markConnectionReusable

    void markConnectionReusable()

#### markConnectionNonReusable

    void markConnectionNonReusable()

#### setConnectionState

    void setConnectionState(Object state)

#### setConnectionValidFor

    void setConnectionValidFor(org.apache.hc.core5.util.TimeValue duration)